#!/bin/bash
#  Creation d'utilisateur a partir d'un fichier
cre1uti() {
	# Controle si fichier dos
	line=$(echo $line | sed 's/
//g')
	# On recupere tous les parametres
	Classe=$(echo $line | cut -d';' -f1 | tr "' A-Z-" "aaaeeeeuuuooc__a-z_")
	if [ -z "$(echo ${Classe:0:1} | tr -d 0-9)" ]; then
		echo "$Classe : nom de classe incorrecte, ne doit pas commencer par un chiffre"
		exit 
	fi
	# On vire les majuscules, accents et autres plaisanteries
	Nom=$(echo $line | cut -d';' -f2| tr "' a-z-" "AAAEEEEUUUOOC__A-Z_" )
	Prenom=$(echo $line | cut -d';' -f3| tr "' A-Z-" "aaaeeeeuuuooc__a-z_" )
	Login=$(echo $line | cut -d';' -f4| tr "' A-Z-" "aaaeeeeuuuooc__a-z_" )
	MotDePasse=$(echo $line | cut -d';' -f5)
	# Creation de la classe si elle n'existe pas 
	if ! grep -s -q "^$Classe:" /etc/group; then
		/var/wwwse/cgi-bin/newclassp.sh $Classe $Classe
	fi
	# Generatio,n du Login si inexistant ou si > 8 caracteres
	if [ -z "$Login" ] || [ "${#Login}" -gt 8 ]; then
		Login=$(echo ${Nom:0:7}${Prenom:0:1} | tr "A-Z" "a-z")
	fi
	cpt=0
	# On verfie que a n'existe pas 
	while true; do
		if grep -s -q "^$Login:" /etc/passwd; then
			let cpt=cpt+1
			Login=${Login:0:7}$cpt
		else
			break
		fi
	done
	# Generation du mot de passe
	if [ -z "$MotDePasse" ]; then
		voyelle="aeiouy"
		consonne="bcdfghjklmnpqrstvwxz"
		chiffre="0123456789"
		for i in $(seq 1 5);do 
			let rdn=$RANDOM%2
			if [ "$rnd" == "0" ]; then
				let rnd=$RANDOM%7
				MotDePasse=$MotDePasse${voyelle:$rnd:1}
			else
				let rnd=$RANDOM%19
				MotDePasse=$MotDePasse${consonne:$rnd:1}
			fi
		done
		for i in 1 2;do
			let rnd=$RANDOM%10
			MotDePasse=$MotDePasse${chiffre:$rnd:1}
		done
	fi
	echo "$Classe;$Nom;$Prenom;$Login;$MotDePasse" >>/serveur/conf/lists/liste_eleves
	echo "$Classe;$Nom;$Prenom;$Login;$MotDePasse
" >>/serveur/home/admin/utilisateurs/$Classe.txt
	echo "$Classe;$Nom;$Prenom;$Login;$MotDePasse" 
	# Creation utilisateur
	# ./createusr.sh $Login $MotDePasse $Classe eleves $clink $cpubweb $cbureau $cstart $prenom $nom`;
	if [ -z "$modele" ]; then modele=$Classe ;fi
	/var/wwwse/cgi-bin//createusr.sh $Login $MotDePasse $Classe $modele con con c c $Prenom $Nom;
	# Rajout de l'utilisateur dans /serveur/conf/lists/$Classe2 avec LOGIN PRENOM NOM
	echo "$Login $Prenom $Nom" >>/serveur/conf/lists/$Classe
	# Rajout user pour squidGuard
	ln -s /serveur/home/$Login /serveur/profs/classes/$Classe
	sudo chown admin:samba /usr/share/squidGuard-1.1.4/db2/user/$Classe
	echo $Login >>/usr/share/squidGuard-1.1.4/db2/user/$Classe

	# Rajout user dans home utilisateur
	sudo mkdir /serveur/home/$Login/login
	sudo echo $Login >>/serveur/home/$Login/login.txt
	sudo echo $Classe >>/serveur/home/$Login/classe.txt
	sudo cp /serveur/home/$Login/*.txt /serveur/home/$Login/login
	sudo chown root.samba /serveur/home/$Login/login/*.txt
	sudo chmod 644 /serveur/home/$Login/login/*.txt
	sudo rm /serveur/home/$Login/*.txt

}
if [ "$1" == "_enligne_" ]; then
	line="$2"
	modele=eleves
	cre1uti 
	exit
fi
if [ "$1" == "_enmodel_" ]; then
	line="$2"
	modele=""
	cre1uti 
	exit
fi
if [ ! -f $1 ]; then
cat <<!EOF!
Syntaxe : create_listep.sh fichier

fichier contient la liste des utilisateurs  crer sous la forme

Classe;Nom;Prenom
ou
Classe;Nom;Prenom;Login;Mot de passe
!EOF!
exit
fi
Fichier=$1
while read line; do
	cre1uti 
done < $Fichier

tb

	# Rajout user dans home utilisateur
	sudo mkdir /serveur/home/$Login/login
	sudo echo $Login >>/serveur/home/$Login/login.txt
	sudo echo $Classe >>/serveur/home/$Login/classe.txt
	sudo cp /serveur/home/$Login/*.txt /serveur/home/$Login/login
	sudo chown root.samba /serveur/home/$Login/login/*.txt
	sudo chmod 644 /serveur/home/$Login/login/*.txt
	sudo rm /serveur/home/$Login/*.txt
