#!/bin/sh

# Migration de groupes

# Olivier LECLUSE    -  olivier.lecluse@linux-france.org
# Licence GPL
# 20 Janvier 2001
# modifications par Philippe PETER le 26/04/2003 pour intgration XP

./entete.sh "Migration de groupe"

QUERY=`./querystr.sh`
eval $QUERY

./strvalid.cgi "$WLOGIN" ||exit 1

if `./cmptnexist.sh $WLOGIN`; then
  echo "<b>ATTENTION :</b> Le compte <b><font color="#FF0066"><i>$verouillnomc</i></font></b> n'existe pas !<BR>"
  echo "Aucune action n'a &eacute;t&eacute; effectu&eacute;e.<BR><BR>"
  exit 1;
fi

if [ "$WGROUP1" != "None" ]; then
        echo "Suppression de <B>$WLOGIN</B> du groupe <B>$WGROUP1</B><BR>"
        /var/wwwse/bin/exe /var/wwwse/cgi-bin/grpusers.pl del $WGROUP1 $WLOGIN
fi

if [ "$WGROUP2" != "None" ]; then
        echo "Ajout de <B>$WLOGIN</B> au groupe <B>$WGROUP2</B><BR>"
        /var/wwwse/bin/exe /var/wwwse/cgi-bin/grpusers.pl add $WGROUP2 $WLOGIN
fi

if [ "$WGROUP1" != "None" ] && [ "$WGROUP2" != "None" ]; then
        echo "Modification du script de login de $WLOGIN"
        cat /serveur/home/netlogon/$WLOGIN.bat | sed -e "s/$WGROUP1/$WGROUP2/g" > /serveur/home/netlogon/$WLOGIN.ba
        mv /serveur/home/netlogon/$WLOGIN.ba /serveur/home/netlogon/$WLOGIN.bat
        /var/wwwse/bin/exe /bin/chmod 770 /serveur/home/netlogon/$WLOGIN.bat
	# modifs pour integration XP
        # rm /serveur/home/$WLOGIN/Demarrer/Programmes/Commun
        # ln -s  /serveur/home/admin/Demarrer/Programmes/Commun/$WGROUP2/ /serveur/home/$WLOGIN/Demarrer/Programmes/Commun
	rm /serveur/home/$WLOGIN/profil/Demarrer/Programmes/Commun
        ln -s  /serveur/home/admin/profil/Demarrer/Programmes/Commun/$WGROUP2/ /serveur/home/$WLOGIN/profil/Demarrer/Programmes/Commun
	# fin modifs
	mv /serveur/home/admin/liens/$WGROUP1/$WLOGIN /serveur/home/admin/liens/$WGROUP2/$WLOGIN
        # Ajout comedu 08/06
	mv /serveur/$WGROUP1/$WLOGIN /serveur/$WGROUP2/$WLOGIN
        grep $WLOGIN /serveur/home/admin/utilisateurs/$WGROUP1.txt >/serveur/home/admin/utilisateurs/$WLOGIN.txt
	perl -pi -e "s/$WGROUP1/$WGROUP2/" /serveur/home/admin/utilisateurs/$WLOGIN.txt
	cat /serveur/home/admin/utilisateurs/$WGROUP1.txt | grep -v $WLOGIN >/serveur/home/admin/utilisateurs/$WGROUP1.txt
	cat /serveur/home/admin/utilisateurs/$WLOGIN.txt >>/serveur/home/admin/utilisateurs/$WGROUP2.txt
	rm /serveur/home/admin/utilisateurs/$WLOGIN.txt
	
fi

cat <<EOF

<HR>
<TABLE BORDER="0" WIDTH="100%">
  <TR>
    <TD><A HREF="/groups.html"><IMG SRC="/icons/back.gif" ALIGN="TOP" BORDER="0"> Retour au menu de gestion des groupes</A></TD>
    <TD ALIGN="RIGHT"><IMG SRC="/icons/apache_pb.gif"></TD>
  </TR>
</TABLE>
</BODY>
</HTML>

EOF
