#!/usr/bin/perl

# Rponse du serveur pour la cration d'usagers pour SambaEdu

# Bruno LEGRIX    bruno.legrix@ac-rouen.fr
# Olivier LECLUSE olivier.lecluse@linux-france.org
# Licence GPL     2000.08.29
# inspir d'un script du projet SLIS - CARMI-Internet (Acadmie de Grenoble - France 38). Bruno Bzeznik <Bruno@ac-grenoble.fr>

use CGI ;
$html = new CGI ;
#print $html->header ;

print `./entete.sh "Rponse pour la cration d'usagers"`;

# Test de validit
if ($html->param('USRLISTE') eq "")
  {
    print "<CENTER>Vous n'avez entr&eacute; aucune information.";
    &echec;
    exit;
  }

# Type de sparation des donnes (sparateur avec ou sans espace)
if ($html->param('espgch') eq 'on') { $seperation=$seperation." "; }
$seperation=$seperation.$html->param('Separ');
if ($html->param('espdte') eq 'on') { $seperation=$seperation." "; }

$groupe = $html->param('WGROUP');
$clink = "c".$html->param('WLINK');
$cbureau = "c".$html->param('WBUREAU');
$cstart = "c".$html->param('WSTART');
$cpubweb = "c".$html->param('WPUBWEB');
$Ordre = $html->param('Ordre');

print "<CENTER><BR><H3>\n";
$NomListe = $html->param('NOMLISTE');
if ($NomListe eq "")
    {print "Il n'y a pas de nom pour cette liste, donc ces usagers ne pourront pas tre dtruits ensemble.";}
  else
    {if (-e "/serveur/conf/lists/".$NomListe) {print "<P><I><B><U>$NomListe</B></U> existe dj, ces usagers sont rajouts.</I>";}
     print "Voici la liste des nouveaux usagers de <B><U>$NomListe</B></U>.";}
print "</H3><BR></CENTER>\n";

open (USERS_TMP,">/serveur/conf/lists/usr-creer-tmp");
  print USERS_TMP $html->param('USRLISTE') ;
  print USERS_TMP " \n" ;
close USERS_TMP ;

print "<CENTER><TABLE BORDER=\"1\">\n";
print "<TABLE><TR><TD><TR><TD><B>Prnom</B></TD><TD><B>Nom</B></TD>";
print "<TD><B>login</B></TD><TD><B>Mot de passe</B></TD></B><TD><B>Groupe principal</B></TD></TR> \n";

open (USERS_TMP,"/serveur/conf/lists/usr-creer-tmp");

boucle: while (<USERS_TMP>)
  {
    # Enleve les retour chariot de fin de ligne (chomp ne me plait pas...)
    if (substr($_,-1,1) eq "\n") {$u=substr($_,0,-2);}
    next boucle if ($u eq "") ;

    # Lecture des champs
    if ($Ordre eq "LPNM") {($login, $prenom, $nom, $passwd) = split(/$seperation/,$u);}
    if ($Ordre eq "PNM")  {($prenom, $nom, $passwd) = split(/$seperation/,$u);}
    if ($Ordre eq "PN")   {($prenom, $nom) = split(/$seperation/,$u);}
    if ($Ordre eq "LNPM") {($login, $nom, $prenom, $passwd) = split(/$seperation/,$u);}
    if ($Ordre eq "NPM")  {($nom, $prenom, $passwd) = split(/$seperation/,$u);}
    if ($Ordre eq "NP")   {($nom, $prenom) = split(/$seperation/,$u);}

    if ($Ordre eq "PN" || $Ordre eq "NP") {$passwd = &generer_pw;}

    # Suppression des accents
    $prenom = fr2uk($prenom);
    $prenom=~ y/A-Z/a-z/;
    $nom = fr2uk($nom);
    $nom=~ y/a-z/A-Z/;

    if ($Ordre eq "PN" || $Ordre eq "NP" || $Ordre eq "PNM" || $Ordre eq "NPM")
      {
        $login1=substr $prenom,0,1;
        $login2=substr $nom,0,7;
        $login="$login2"."$login1";
      }

    # Suppression des accents
    $login = fr2uk($login) ;
    $login=~ y/A-Z/a-z/;

    # Au cas ou le login existe deja dans /etc/passwd ou dans le fichier en cours.
    $already=`cut -d: -f1 /etc/passwd | grep -x $login` ;
    $c=0 ;
    $login1=substr($login,0,6);
    while ($already ne "")
      {
        $c += 1 ;
        $login="$login1"."$c";
        $already=`cut -d: -f1 /etc/passwd | grep -x $login` ;
      }

    print "<TR><TD>$prenom</TD><TD>$nom</TD><TD>$login</TD><TD>$passwd</TD><TD>$groupe</TD></TR>\n";

    # Ecriture dans le fichier  "$WLOGIN $WPASSWD $WGROUP $WGROUP $WLINK $WBUREAU $WSTART $WPRENOM $WNOM"
    `./createusr.sh $login $passwd $groupe $groupe $clink $cpubweb $cbureau $cstart $prenom $nom`;

    if ($NomListe ne "")
      {
        open (USR_LISTE,">>/serveur/conf/lists/$NomListe");
          print USR_LISTE "$login $prenom $nom $passwd $groupe\n";
        close USR_LISTE;
      }

  }

close USERS_TMP ;
`rm -rf /serveur/conf/lists/usr-creer-tmp`;
`chmod 700 /serveur/conf/lists/$NomListe`;

# Ecriture du resultat
print "</TD></TR></TABLE></TABLE><P>" ;
#print `./queue-fin-2-html.sh`;
#print "<H3><I>Les informations ont &eacute;t&eacute; enregistr&eacute;es" ;
#print "\n</I></H3><P>Ces comptes seront actifs dans une petite minute.<P>\n" ;
#print "Il n'y a pas eu de gros problmes <BR></CENTER>";
print "<P><B><A HREF=newlisthtml.cgi>Cr&eacute;er d'autres comptes</A></B><BR>\n" ;

&fin;
close(PARAMS);

###################
# Sous-programmes #
###################

sub fin
  {
    print "<HR>
<TABLE BORDER='0' WIDTH='100%'>
  <TR>
    <TD><A HREF='/users.html'><IMG SRC='/icons/back.gif' ALIGN='TOP' BORDER='0'> Retour au menu de gestion des utilisateurs</A></TD>
    <TD ALIGN='RIGHT'><IMG SRC='/icons/apache_pb.gif'></TD>
  </TR>
</TABLE>
</BODY>
</HTML>";
  }

sub echec
  {
    print "<BR>";
    print "<CENTER><A HREF=/newlisthtml.cgi> Recommencez la demande.</A></CENTER>\n";
    fin;
  }

sub generer_pw
  {
    local(@voyelles, @consonnes, @nombres, $rnd_pw, $rnd_num, $qdv);
    @voyelles = ('a', 'e', 'i', 'o', 'u', 'y');
    @consonnes = ('b'..'d', 'f'..'h', 'j'..'n', 'p'..'t', 'v'..'x', 'z');
    @nombres = ('0'..'9');
    $rnd_pw = "";
    $qdv = int(rand(2));

    for ($i = 1; $i < 5; $i++)
      {
        if ($i % 2 == $qdv)
          {
            $rnd_num = int(rand($#voyelles + 1));
            $rnd_pw .= @voyelles[$rnd_num];
          }
          else
          {
            $rnd_num = int(rand($#consonnes + 1));
            $rnd_pw .= @consonnes[$rnd_num];
          }
      }
    for ($i = 5; $i < 7; $i++)
      {
        $rnd_num = int(rand($#nombres + 1));
        $rnd_pw .= @nombres[$rnd_num];
      }
    return $rnd_pw;
  }

sub fr2uk
  {
    my($motfr) = @_;
    $motfr=~ s//a/g ;
    $motfr=~ s//a/g ;
    $motfr=~ s//a/g ;
    $motfr=~ s//e/g ;
    $motfr=~ s//e/g ;
    $motfr=~ s//e/g ;
    $motfr=~ s//e/g ;
    $motfr=~ s//u/g ;
    $motfr=~ s//u/g ;
    $motfr=~ s//u/g ;
    $motfr=~ s//o/g ;
    $motfr=~ s//o/g ;
    $motfr=~ s//c/g ;
    $motfr=~ s/'//g ;
    $motfr=~ s/ //g ;
    return $motfr;
  }
